/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-baxter-core-msgs-1.1.1-0precise-20150519-1335/srv/SolvePositionIK.srv
 *
 */


#ifndef BAXTER_CORE_MSGS_MESSAGE_SOLVEPOSITIONIKRESPONSE_H
#define BAXTER_CORE_MSGS_MESSAGE_SOLVEPOSITIONIKRESPONSE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <sensor_msgs/JointState.h>

namespace baxter_core_msgs
{
template <class ContainerAllocator>
struct SolvePositionIKResponse_
{
  typedef SolvePositionIKResponse_<ContainerAllocator> Type;

  SolvePositionIKResponse_()
    : joints()
    , isValid()
    , result_type()  {
    }
  SolvePositionIKResponse_(const ContainerAllocator& _alloc)
    : joints(_alloc)
    , isValid(_alloc)
    , result_type(_alloc)  {
    }



   typedef std::vector< ::sensor_msgs::JointState_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::sensor_msgs::JointState_<ContainerAllocator> >::other >  _joints_type;
  _joints_type joints;

   typedef std::vector<uint8_t, typename ContainerAllocator::template rebind<uint8_t>::other >  _isValid_type;
  _isValid_type isValid;

   typedef std::vector<uint8_t, typename ContainerAllocator::template rebind<uint8_t>::other >  _result_type_type;
  _result_type_type result_type;


    enum { RESULT_INVALID = 0 };
 

  typedef boost::shared_ptr< ::baxter_core_msgs::SolvePositionIKResponse_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::baxter_core_msgs::SolvePositionIKResponse_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct SolvePositionIKResponse_

typedef ::baxter_core_msgs::SolvePositionIKResponse_<std::allocator<void> > SolvePositionIKResponse;

typedef boost::shared_ptr< ::baxter_core_msgs::SolvePositionIKResponse > SolvePositionIKResponsePtr;
typedef boost::shared_ptr< ::baxter_core_msgs::SolvePositionIKResponse const> SolvePositionIKResponseConstPtr;

// constants requiring out of line definition

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::baxter_core_msgs::SolvePositionIKResponse_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::baxter_core_msgs::SolvePositionIKResponse_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace baxter_core_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'sensor_msgs': ['/opt/ros/hydro/share/sensor_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'baxter_core_msgs': ['/tmp/buildd/ros-hydro-baxter-core-msgs-1.1.1-0precise-20150519-1335/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::baxter_core_msgs::SolvePositionIKResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::baxter_core_msgs::SolvePositionIKResponse_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::baxter_core_msgs::SolvePositionIKResponse_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::baxter_core_msgs::SolvePositionIKResponse_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::baxter_core_msgs::SolvePositionIKResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::baxter_core_msgs::SolvePositionIKResponse_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::baxter_core_msgs::SolvePositionIKResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "d9b0c2b3932e08421f5094cf62743b9f";
  }

  static const char* value(const ::baxter_core_msgs::SolvePositionIKResponse_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xd9b0c2b3932e0842ULL;
  static const uint64_t static_value2 = 0x1f5094cf62743b9fULL;
};

template<class ContainerAllocator>
struct DataType< ::baxter_core_msgs::SolvePositionIKResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "baxter_core_msgs/SolvePositionIKResponse";
  }

  static const char* value(const ::baxter_core_msgs::SolvePositionIKResponse_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::baxter_core_msgs::SolvePositionIKResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "\n\
sensor_msgs/JointState[] joints\n\
\n\
\n\
bool[] isValid\n\
\n\
\n\
\n\
uint8 RESULT_INVALID = 0\n\
uint8[] result_type\n\
\n\
\n\
================================================================================\n\
MSG: sensor_msgs/JointState\n\
# This is a message that holds data to describe the state of a set of torque controlled joints. \n\
#\n\
# The state of each joint (revolute or prismatic) is defined by:\n\
#  * the position of the joint (rad or m),\n\
#  * the velocity of the joint (rad/s or m/s) and \n\
#  * the effort that is applied in the joint (Nm or N).\n\
#\n\
# Each joint is uniquely identified by its name\n\
# The header specifies the time at which the joint states were recorded. All the joint states\n\
# in one message have to be recorded at the same time.\n\
#\n\
# This message consists of a multiple arrays, one for each part of the joint state. \n\
# The goal is to make each of the fields optional. When e.g. your joints have no\n\
# effort associated with them, you can leave the effort array empty. \n\
#\n\
# All arrays in this message should have the same size, or be empty.\n\
# This is the only way to uniquely associate the joint name with the correct\n\
# states.\n\
\n\
\n\
Header header\n\
\n\
string[] name\n\
float64[] position\n\
float64[] velocity\n\
float64[] effort\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
";
  }

  static const char* value(const ::baxter_core_msgs::SolvePositionIKResponse_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::baxter_core_msgs::SolvePositionIKResponse_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.joints);
      stream.next(m.isValid);
      stream.next(m.result_type);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct SolvePositionIKResponse_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::baxter_core_msgs::SolvePositionIKResponse_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::baxter_core_msgs::SolvePositionIKResponse_<ContainerAllocator>& v)
  {
    s << indent << "joints[]" << std::endl;
    for (size_t i = 0; i < v.joints.size(); ++i)
    {
      s << indent << "  joints[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::sensor_msgs::JointState_<ContainerAllocator> >::stream(s, indent + "    ", v.joints[i]);
    }
    s << indent << "isValid[]" << std::endl;
    for (size_t i = 0; i < v.isValid.size(); ++i)
    {
      s << indent << "  isValid[" << i << "]: ";
      Printer<uint8_t>::stream(s, indent + "  ", v.isValid[i]);
    }
    s << indent << "result_type[]" << std::endl;
    for (size_t i = 0; i < v.result_type.size(); ++i)
    {
      s << indent << "  result_type[" << i << "]: ";
      Printer<uint8_t>::stream(s, indent + "  ", v.result_type[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // BAXTER_CORE_MSGS_MESSAGE_SOLVEPOSITIONIKRESPONSE_H
